#ifndef DEMOLINES_H
#define DEMOLINES_H
#include "videoGlobals.h"
// This is just the color demo, allowing you to see the range of colors we can produce.
// To show we're actually producing 640x480, just set the two pixels to different colors
// To see an ugly demonstration of quick switching back and forth.

void doColorScanLine (byte colorByte)
{
  // Remember, 2 pixels at a time:
  // R1 G1 B1 R2 x G2 x B2
  // after vsync we do the back porch
  if (backPorchLinesToGo)
  {
    backPorchLinesToGo--;
    return;   
  }  // end still doing back porch
  if (vLine >= verticalPixels) return;
  
  nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
  PORTD = colorByte;
  vLine++;

}  // end of doColorScanLine()

void drawTheRainbow() {
 switch (whichColor) {
    case 0:
    for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B10000000); //Red/Black
      }
      break;
    case 1:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B10010000); //Red
      }
      break;
    case 2:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B10010100); //Red/Yellow
      }
      break;
    case 3:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B11010100); // Yellow
      }
      break;
     case 4:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B11000100); // Yellow/Green
      }
      break;
     case 5:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B01000100); // Green
      }
      break;
     case 6:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B01000101); // Green/Cyan
      }
      break;
    case 7:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B01100101); // Cyan
      }
      break;
    case 8:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B01100001); // Cyan/Blue
      }
      break;
    case 9:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B00100001); // Blue
      }
      break;
    case 10:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B00100101); // Blue/Violet
      }
      break;
    case 11:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B10100101); // Violet
      }
      break;
    case 12:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B10100000); // Violet/Black
      }
      break;
    default:
      for (unsigned int i = 0; i<20; ++i) {
        sleep_mode();
        doColorScanLine(B00000000); //Black, but of course.
      }
      break;
 } // end rainbow switch
}

#endif
