#ifndef _VIDEOGLOBALS_H
#define _VIDEOGLOBALS_H


const int verticalPixels = 480;  // 480 pixels high


const int  verticalLines = verticalPixels;  
const byte verticalBackPorchLines = 30;  // includes sync pulse?
const int  verticalFrontPorchLines = 520 - verticalBackPorchLines;


// Don't let the compiler optimize
volatile int vLine; // Vertical Line Number
volatile int frames; // What frame # out of 60 are we currently drawing
volatile int whichMessage; // Because who wants to see the same message all the time?
volatile int whichColor; // Can't update every frame - 60Hz color changes are ugly.
volatile byte backPorchLinesToGo;

// Useful for timing purposes!
#define nop asm volatile ("nop\n\t")

// ISR: Vsync pulse
ISR (TIMER1_OVF_vect)
{
  vLine = 0; 
  backPorchLinesToGo = verticalBackPorchLines;
  
  // Rainbow effect
  if (frames % 8 == 0){
     ++whichColor;
  }
  
  if (frames % 52 == 0) {
     ++whichMessage; 
  }
  
  if (++frames == 104) { // Gives us 14 colors in our rainbow
     frames = 1; 
     whichColor = 0;
     whichMessage = 0;
  } 
} // end of TIMER1_OVF_vect

// ISR: Hsync pulse ... this interrupt merely wakes us up when we're in sleep mode.
ISR (TIMER2_OVF_vect)
{
} // end of TIMER2_OVF_vect

#endif
